#ifndef __INCLUDE__E2T__H__
#define __INCLUDE__E2T__H__

#ifdef vxWorks
#include <stdlib.h>
#include <stddef.h>
#include <string.h>
#include <stdio.h>

#include <vxWorks.h>
#include <timexLib.h>
#include <ioLib.h>
#include "taskLib.h"
#include "moduleLib.h"
#include "loadLib.h"
#include "fast_lock.h"
#endif	/* vxWorks */

#ifdef UNIX
#define INCLsemLibh
#define INCLvxLibh
#endif	/* UNIX */

/* TINE includes */
/* Albert #include "app_version.h" */
#include "stdio.h" /* Albert */
#include "tine.h"

/* #include "dbDefs.h"
#include "errlog.h"
#include "ellLib.h"
#include "dbBase.h"
#include "dbCommon.h"
#include "dbLock.h"
#include "recSup.h"
#include "devSup.h"
#include "drvSup.h"
#include "recGbl.h"
#include "special.h"
#include "dbEvent.h"
#include "ellLib.h"
#include "callback.h"
#include "freeList.h"
#include "cvtFast.h" */

#include "dbAccess.h"
#include "dbStaticLib.h"
#include "cvtFast.h"
#include <epicsVersion.h>

typedef struct
{
  int severity;
  int code;
  int system;
  char tag[16];
  char text[40];
  char url[40];
} E2T_ALARM_XREF;
#define USR_ALARM_OFFSET 512

extern struct dbBase *pdbbase;

#define DZK(c)   if(verboseTINE) {c}
long verboseTINE = 0;

#define MAXLINE 80
typedef struct {		/* line output structure */
    char            out_buff[MAXLINE + 1];
    char           *pNext;
    char           *pLast;
    char           *pNexTab;
    char            message[128];
} TAB_BUFFER;

#ifndef MIN
#define MIN(x,y)        ((x < y)?x:y)
#endif
#ifndef MAX
#define MAX(x,y)        ((x > y)?x:y)
#endif

/* Defines */
#define CONFIG_FILE	"e2t.cfg"
#define TINE_FREE_PROPERTIES	5

/* Prototypes */
long tineGetNumRecords();
long tineGetRecords(NAME64 *pname);
long tineGetRecords();

long tineGetRecordNamesAndTypes();

void tineTest();
long tineGetRecordTypes();
int  tineGetFieldValue(char *pname, char *pprop, void *ptr, int tineFmt, int len, int *pCount);
/* OLDint tineGetAlarmLimits(char *recName, ALARM_WATCH_THRESHOLDS *pThr, int *pSeverity); */
int tineGetAlarmLimits(char *recName, E2T_ALARM_XREF *pThr);
/* OLD int tineSetAlarm(int sev,int st, float v); */
int tineSetAlarm(char *chname,int sev,int status,float fval);


long tinePutFieldValue(char *pname,char *pvalue);
short getTINEformat(int epicsFmt);

void KeepTineSrvAlive();
int GetDataBaseSize(char *filename);
int findcol(char *str,char *tag);
char *colptr(int col,char *str);
void startE2T();

typedef struct devChainStruct
{
  char name[64];
  struct devChainStruct *next;
} devChain;

typedef struct {
  char  name[64];
  char  desc[96];
  char separater[2];
  devChain *devs;
  short fmt;
  short elem;
  int ndev;
} Tproperty;

typedef struct {
  char devName[64];
  char devProperty[64];
  int  prpLength;
  int  prpFormat;
  char prpDesc[64];
  int  numCmpPrps;
  NAME64 *cmpPrps;
  NAME64 *cmpDevPrps;
  NAME64 *cmpDevs;
  NAME64 *cmpAliasDevs;
  NAME64 *cmpDesc;
} COMPOSITE;

int readStructureFile( char *filename, NAME64 **cmpPrps, NAME64 **cmpDevPrps, NAME64 **cmpDevs, NAME64 **cmpAliasDevs, NAME64 **cmpDesc, int *numCmpProperties);
int readCompositeFile(char *cmpFileName);
/* short getTINEformat(int epicsFmt); */
int fillDeviceNamesAndProperties(char *fec,char *server,NAME64 **devnames,int *numDevices,Tproperty **prp,int *numProperties);
int gtweqm(char *devName,char *devProperty,DTYPE *dout, DTYPE *din,short access);
int E2T();

#if ((EPICS_VERSION==3 && EPICS_REVISION>=14) || EPICS_VERSION>3)
#define EPICS_3_14 1
#undef EPICS_3_13
#endif /* version calculation */

#endif /* __INCLUDE__E2T__H__ */
/* End of file */
